//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/dom/DOMTypes.h"


//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct MessagePortIdentifier|
//
namespace mozilla {
namespace dom {
auto MessagePortIdentifier::operator==(const MessagePortIdentifier& _o) const -> bool
{
    if ((!((uuid()) == ((_o).uuid())))) {
        return false;
    }
    if ((!((destinationUuid()) == ((_o).destinationUuid())))) {
        return false;
    }
    if ((!((sequenceId()) == ((_o).sequenceId())))) {
        return false;
    }
    if ((!((neutered()) == ((_o).neutered())))) {
        return false;
    }
    return true;
}

auto MessagePortIdentifier::operator!=(const MessagePortIdentifier& _o) const -> bool
{
    return (!(operator==(_o)));
}

} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct ClonedMessageData|
//
namespace mozilla {
namespace dom {
auto ClonedMessageData::operator==(const ClonedMessageData& _o) const -> bool
{
    if ((!((data()) == ((_o).data())))) {
        return false;
    }
    if ((!((blobs()) == ((_o).blobs())))) {
        return false;
    }
    if ((!((inputStreams()) == ((_o).inputStreams())))) {
        return false;
    }
    if ((!((identfiers()) == ((_o).identfiers())))) {
        return false;
    }
    return true;
}

auto ClonedMessageData::operator!=(const ClonedMessageData& _o) const -> bool
{
    return (!(operator==(_o)));
}

} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |union IPCDataTransferData|
//
namespace mozilla {
namespace dom {
auto IPCDataTransferData::MaybeDestroy(Type aNewType) -> bool
{
    if ((mType) == (T__None)) {
        return true;
    }
    if ((mType) == (aNewType)) {
        return false;
    }
    switch (mType) {
    case TnsString:
        {
            (ptr_nsString())->~nsString__tdef();
            break;
        }
    case TShmem:
        {
            (ptr_Shmem())->~Shmem__tdef();
            break;
        }
    case TIPCBlob:
        {
            (ptr_IPCBlob())->~IPCBlob__tdef();
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("not reached");
            break;
        }
    }
    return true;
}

MOZ_IMPLICIT IPCDataTransferData::IPCDataTransferData(const nsString& aOther)
{
    new (mozilla::KnownNotNull, ptr_nsString()) nsString(aOther);
    mType = TnsString;
}

MOZ_IMPLICIT IPCDataTransferData::IPCDataTransferData(nsString&& aOther)
{
    new (mozilla::KnownNotNull, ptr_nsString()) nsString(mozilla::Move(aOther));
    mType = TnsString;
}

MOZ_IMPLICIT IPCDataTransferData::IPCDataTransferData(Shmem& aOther)
{
    new (mozilla::KnownNotNull, ptr_Shmem()) Shmem(aOther);
    mType = TShmem;
}

MOZ_IMPLICIT IPCDataTransferData::IPCDataTransferData(Shmem&& aOther)
{
    new (mozilla::KnownNotNull, ptr_Shmem()) Shmem(mozilla::Move(aOther));
    mType = TShmem;
}

MOZ_IMPLICIT IPCDataTransferData::IPCDataTransferData(const IPCBlob& aOther)
{
    new (mozilla::KnownNotNull, ptr_IPCBlob()) IPCBlob(aOther);
    mType = TIPCBlob;
}

MOZ_IMPLICIT IPCDataTransferData::IPCDataTransferData(IPCBlob&& aOther)
{
    new (mozilla::KnownNotNull, ptr_IPCBlob()) IPCBlob(mozilla::Move(aOther));
    mType = TIPCBlob;
}

MOZ_IMPLICIT IPCDataTransferData::IPCDataTransferData(const IPCDataTransferData& aOther)
{
    (aOther).AssertSanity();
    switch ((aOther).type()) {
    case TnsString:
        {
            new (mozilla::KnownNotNull, ptr_nsString()) nsString((aOther).get_nsString());
            break;
        }
    case TShmem:
        {
            new (mozilla::KnownNotNull, ptr_Shmem()) Shmem((aOther).get_Shmem());
            break;
        }
    case TIPCBlob:
        {
            new (mozilla::KnownNotNull, ptr_IPCBlob()) IPCBlob((aOther).get_IPCBlob());
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    mType = (aOther).type();
}

MOZ_IMPLICIT IPCDataTransferData::IPCDataTransferData(IPCDataTransferData&& aOther)
{
    (aOther).AssertSanity();
    Type t = (aOther).type();
    switch (t) {
    case TnsString:
        {
            new (mozilla::KnownNotNull, ptr_nsString()) nsString(mozilla::Move((aOther).get_nsString()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case TShmem:
        {
            new (mozilla::KnownNotNull, ptr_Shmem()) Shmem(mozilla::Move((aOther).get_Shmem()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case TIPCBlob:
        {
            new (mozilla::KnownNotNull, ptr_IPCBlob()) IPCBlob(mozilla::Move((aOther).get_IPCBlob()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    (aOther).mType = T__None;
    mType = t;
}

IPCDataTransferData::~IPCDataTransferData()
{
    static_cast<void>(MaybeDestroy(T__None));
}

auto IPCDataTransferData::operator=(const nsString& aRhs) -> IPCDataTransferData&
{
    if (MaybeDestroy(TnsString)) {
        new (mozilla::KnownNotNull, ptr_nsString()) nsString;
    }
    (*(ptr_nsString())) = aRhs;
    mType = TnsString;
    return (*(this));
}

auto IPCDataTransferData::operator=(nsString&& aRhs) -> IPCDataTransferData&
{
    if (MaybeDestroy(TnsString)) {
        new (mozilla::KnownNotNull, ptr_nsString()) nsString;
    }
    (*(ptr_nsString())) = mozilla::Move(aRhs);
    mType = TnsString;
    return (*(this));
}

auto IPCDataTransferData::operator=(Shmem& aRhs) -> IPCDataTransferData&
{
    if (MaybeDestroy(TShmem)) {
        new (mozilla::KnownNotNull, ptr_Shmem()) Shmem;
    }
    (*(ptr_Shmem())) = aRhs;
    mType = TShmem;
    return (*(this));
}

auto IPCDataTransferData::operator=(Shmem&& aRhs) -> IPCDataTransferData&
{
    if (MaybeDestroy(TShmem)) {
        new (mozilla::KnownNotNull, ptr_Shmem()) Shmem;
    }
    (*(ptr_Shmem())) = mozilla::Move(aRhs);
    mType = TShmem;
    return (*(this));
}

auto IPCDataTransferData::operator=(const IPCBlob& aRhs) -> IPCDataTransferData&
{
    if (MaybeDestroy(TIPCBlob)) {
        new (mozilla::KnownNotNull, ptr_IPCBlob()) IPCBlob;
    }
    (*(ptr_IPCBlob())) = aRhs;
    mType = TIPCBlob;
    return (*(this));
}

auto IPCDataTransferData::operator=(IPCBlob&& aRhs) -> IPCDataTransferData&
{
    if (MaybeDestroy(TIPCBlob)) {
        new (mozilla::KnownNotNull, ptr_IPCBlob()) IPCBlob;
    }
    (*(ptr_IPCBlob())) = mozilla::Move(aRhs);
    mType = TIPCBlob;
    return (*(this));
}

auto IPCDataTransferData::operator=(const IPCDataTransferData& aRhs) -> IPCDataTransferData&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TnsString:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_nsString()) nsString;
            }
            (*(ptr_nsString())) = (aRhs).get_nsString();
            break;
        }
    case TShmem:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_Shmem()) Shmem;
            }
            (*(ptr_Shmem())) = (aRhs).get_Shmem();
            break;
        }
    case TIPCBlob:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_IPCBlob()) IPCBlob;
            }
            (*(ptr_IPCBlob())) = (aRhs).get_IPCBlob();
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    mType = t;
    return (*(this));
}

auto IPCDataTransferData::operator=(IPCDataTransferData&& aRhs) -> IPCDataTransferData&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TnsString:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_nsString()) nsString;
            }
            (*(ptr_nsString())) = mozilla::Move((aRhs).get_nsString());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case TShmem:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_Shmem()) Shmem;
            }
            (*(ptr_Shmem())) = mozilla::Move((aRhs).get_Shmem());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case TIPCBlob:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_IPCBlob()) IPCBlob;
            }
            (*(ptr_IPCBlob())) = mozilla::Move((aRhs).get_IPCBlob());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    (aRhs).mType = T__None;
    mType = t;
    return (*(this));
}

auto IPCDataTransferData::operator==(const nsString& aRhs) const -> bool
{
    return (get_nsString()) == (aRhs);
}

auto IPCDataTransferData::operator==(Shmem& aRhs) const -> bool
{
    return (get_Shmem()) == (aRhs);
}

auto IPCDataTransferData::operator==(const IPCBlob& aRhs) const -> bool
{
    return (get_IPCBlob()) == (aRhs);
}

auto IPCDataTransferData::operator==(const IPCDataTransferData& aRhs) const -> bool
{
    if ((type()) != ((aRhs).type())) {
        return false;
    }

    switch (type()) {
    case TnsString:
        {
            return (get_nsString()) == ((aRhs).get_nsString());
        }
    case TShmem:
        {
            return (get_Shmem()) == ((aRhs).get_Shmem());
        }
    case TIPCBlob:
        {
            return (get_IPCBlob()) == ((aRhs).get_IPCBlob());
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return false;
        }
    }
}

auto IPCDataTransferData::get(nsString* aOutValue) const -> void
{
    (*(aOutValue)) = get_nsString();
}

auto IPCDataTransferData::get(Shmem* aOutValue) const -> void
{
    (*(aOutValue)) = get_Shmem();
}

auto IPCDataTransferData::get(IPCBlob* aOutValue) const -> void
{
    (*(aOutValue)) = get_IPCBlob();
}

} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct IPCDataTransferImage|
//
namespace mozilla {
namespace dom {
auto IPCDataTransferImage::operator==(const IPCDataTransferImage& _o) const -> bool
{
    if ((!((width()) == ((_o).width())))) {
        return false;
    }
    if ((!((height()) == ((_o).height())))) {
        return false;
    }
    if ((!((stride()) == ((_o).stride())))) {
        return false;
    }
    if ((!((format()) == ((_o).format())))) {
        return false;
    }
    return true;
}

auto IPCDataTransferImage::operator!=(const IPCDataTransferImage& _o) const -> bool
{
    return (!(operator==(_o)));
}

} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct IPCDataTransferItem|
//
namespace mozilla {
namespace dom {
auto IPCDataTransferItem::operator==(const IPCDataTransferItem& _o) const -> bool
{
    if ((!((flavor()) == ((_o).flavor())))) {
        return false;
    }
    if ((!((imageDetails()) == ((_o).imageDetails())))) {
        return false;
    }
    if ((!((data()) == ((_o).data())))) {
        return false;
    }
    return true;
}

auto IPCDataTransferItem::operator!=(const IPCDataTransferItem& _o) const -> bool
{
    return (!(operator==(_o)));
}

} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct IPCDataTransfer|
//
namespace mozilla {
namespace dom {
auto IPCDataTransfer::operator==(const IPCDataTransfer& _o) const -> bool
{
    if ((!((items()) == ((_o).items())))) {
        return false;
    }
    return true;
}

auto IPCDataTransfer::operator!=(const IPCDataTransfer& _o) const -> bool
{
    return (!(operator==(_o)));
}

} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct ScreenDetails|
//
namespace mozilla {
namespace dom {
auto ScreenDetails::operator==(const ScreenDetails& _o) const -> bool
{
    if ((!((rect()) == ((_o).rect())))) {
        return false;
    }
    if ((!((rectDisplayPix()) == ((_o).rectDisplayPix())))) {
        return false;
    }
    if ((!((availRect()) == ((_o).availRect())))) {
        return false;
    }
    if ((!((availRectDisplayPix()) == ((_o).availRectDisplayPix())))) {
        return false;
    }
    if ((!((pixelDepth()) == ((_o).pixelDepth())))) {
        return false;
    }
    if ((!((colorDepth()) == ((_o).colorDepth())))) {
        return false;
    }
    if ((!((contentsScaleFactor()) == ((_o).contentsScaleFactor())))) {
        return false;
    }
    if ((!((defaultCSSScaleFactor()) == ((_o).defaultCSSScaleFactor())))) {
        return false;
    }
    if ((!((dpi()) == ((_o).dpi())))) {
        return false;
    }
    return true;
}

auto ScreenDetails::operator!=(const ScreenDetails& _o) const -> bool
{
    return (!(operator==(_o)));
}

} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct DimensionInfo|
//
namespace mozilla {
namespace dom {
auto DimensionInfo::operator==(const DimensionInfo& _o) const -> bool
{
    if ((!((rect()) == ((_o).rect())))) {
        return false;
    }
    if ((!((size()) == ((_o).size())))) {
        return false;
    }
    if ((!((orientation()) == ((_o).orientation())))) {
        return false;
    }
    if ((!((clientOffset()) == ((_o).clientOffset())))) {
        return false;
    }
    if ((!((chromeDisp()) == ((_o).chromeDisp())))) {
        return false;
    }
    return true;
}

auto DimensionInfo::operator!=(const DimensionInfo& _o) const -> bool
{
    return (!(operator==(_o)));
}

} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct FrameScriptInfo|
//
namespace mozilla {
namespace dom {
auto FrameScriptInfo::operator==(const FrameScriptInfo& _o) const -> bool
{
    if ((!((url()) == ((_o).url())))) {
        return false;
    }
    if ((!((runInGlobalScope()) == ((_o).runInGlobalScope())))) {
        return false;
    }
    return true;
}

auto FrameScriptInfo::operator!=(const FrameScriptInfo& _o) const -> bool
{
    return (!(operator==(_o)));
}

} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct CreatedWindowInfo|
//
namespace mozilla {
namespace dom {
auto CreatedWindowInfo::operator==(const CreatedWindowInfo& _o) const -> bool
{
    if ((!((rv()) == ((_o).rv())))) {
        return false;
    }
    if ((!((windowOpened()) == ((_o).windowOpened())))) {
        return false;
    }
    if ((!((frameScripts()) == ((_o).frameScripts())))) {
        return false;
    }
    if ((!((urlToLoad()) == ((_o).urlToLoad())))) {
        return false;
    }
    if ((!((textureFactoryIdentifier()) == ((_o).textureFactoryIdentifier())))) {
        return false;
    }
    if ((!((layersId()) == ((_o).layersId())))) {
        return false;
    }
    if ((!((compositorOptions()) == ((_o).compositorOptions())))) {
        return false;
    }
    if ((!((maxTouchPoints()) == ((_o).maxTouchPoints())))) {
        return false;
    }
    if ((!((dimensions()) == ((_o).dimensions())))) {
        return false;
    }
    return true;
}

auto CreatedWindowInfo::operator!=(const CreatedWindowInfo& _o) const -> bool
{
    return (!(operator==(_o)));
}

} // namespace dom
} // namespace mozilla
