//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PHandlerServiceParent_h
#define PHandlerServiceParent_h

#include "mozilla/dom/PHandlerService.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {


class PHandlerServiceParent :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::dom::PContentParent;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::ByteBuf ByteBuf;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::dom::HandlerApp HandlerApp;
    typedef mozilla::dom::HandlerInfo HandlerInfo;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::dom::PContentParent PContentParent;
    typedef mozilla::dom::PContentChild PContentChild;

    typedef PHandlerService::State State;

protected:
    virtual mozilla::ipc::IPCResult
    RecvFillHandlerInfo(
            const HandlerInfo& aHandlerInfoData,
            const nsCString& aOverrideType,
            HandlerInfo* handlerInfoData) = 0;
    virtual mozilla::ipc::IPCResult
    RecvExistsForProtocol(
            const nsCString& aProtocolScheme,
            bool* exists) = 0;
    virtual mozilla::ipc::IPCResult
    RecvExists(
            const HandlerInfo& aHandlerInfo,
            bool* exists) = 0;
    virtual mozilla::ipc::IPCResult
    RecvGetTypeFromExtension(
            const nsCString& aFileExtension,
            nsCString* type) = 0;
    virtual mozilla::ipc::IPCResult
    Recv__delete__();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PHandlerServiceParent();

    virtual ~PHandlerServiceParent();

    PContentParent*
    Manager() const;

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__) override;

    int32_t
    GetProtocolTypeId() override;

private:
    const char*
    ProtocolName() const override;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            PickleIterator* iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const PHandlerServiceParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PHandlerServiceParent** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    void
    Write(
            const HandlerInfo& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            HandlerInfo* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const nsTArray<HandlerApp>& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            nsTArray<HandlerApp>* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const HandlerApp& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            HandlerApp* v__,
            const Message* msg__,
            PickleIterator* iter__);

    State mState;
};


} // namespace dom
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace dom {
class HandlerServiceParent :
    public PHandlerServiceParent
{
    mozilla::ipc::IPCResult
    RecvFillHandlerInfo(
            const HandlerInfo& aHandlerInfoData,
            const nsCString& aOverrideType,
            HandlerInfo* handlerInfoData) override;

    mozilla::ipc::IPCResult
    RecvExistsForProtocol(
            const nsCString& aProtocolScheme,
            bool* exists) override;

    mozilla::ipc::IPCResult
    RecvExists(
            const HandlerInfo& aHandlerInfo,
            bool* exists) override;

    mozilla::ipc::IPCResult
    RecvGetTypeFromExtension(
            const nsCString& aFileExtension,
            nsCString* type) override;

    void
    ActorDestroy(ActorDestroyReason aWhy) override;

    MOZ_IMPLICIT HandlerServiceParent();
    virtual ~HandlerServiceParent();
};
} // namespace dom
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace dom {
mozilla::ipc::IPCResult
HandlerServiceParent::RecvFillHandlerInfo(
        const HandlerInfo& aHandlerInfoData,
        const nsCString& aOverrideType,
        HandlerInfo* handlerInfoData)
{
}

mozilla::ipc::IPCResult
HandlerServiceParent::RecvExistsForProtocol(
        const nsCString& aProtocolScheme,
        bool* exists)
{
}

mozilla::ipc::IPCResult
HandlerServiceParent::RecvExists(
        const HandlerInfo& aHandlerInfo,
        bool* exists)
{
}

mozilla::ipc::IPCResult
HandlerServiceParent::RecvGetTypeFromExtension(
        const nsCString& aFileExtension,
        nsCString* type)
{
}

void
HandlerServiceParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT HandlerServiceParent::HandlerServiceParent()
{
    MOZ_COUNT_CTOR(HandlerServiceParent);
}

MOZ_IMPLICIT HandlerServiceParent::~HandlerServiceParent()
{
    MOZ_COUNT_DTOR(HandlerServiceParent);
}

} // namespace dom
} // namespace mozilla
#endif // if 0

#endif // ifndef PHandlerServiceParent_h
