//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PWebAuthnTransactionParent_h
#define PWebAuthnTransactionParent_h

#include "mozilla/dom/PWebAuthnTransaction.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

namespace mozilla {
namespace ipc {
class PBackgroundParent;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PBackgroundChild;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PBackgroundParent;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace dom {


class PWebAuthnTransactionParent :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::ipc::PBackgroundParent;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::ByteBuf ByteBuf;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::dom::WebAuthnAuthenticatorSelection WebAuthnAuthenticatorSelection;
    typedef mozilla::dom::WebAuthnExtension WebAuthnExtension;
    typedef mozilla::dom::WebAuthnExtensionAppId WebAuthnExtensionAppId;
    typedef mozilla::dom::WebAuthnExtensionResult WebAuthnExtensionResult;
    typedef mozilla::dom::WebAuthnExtensionResultAppId WebAuthnExtensionResultAppId;
    typedef mozilla::dom::WebAuthnGetAssertionInfo WebAuthnGetAssertionInfo;
    typedef mozilla::dom::WebAuthnGetAssertionResult WebAuthnGetAssertionResult;
    typedef mozilla::dom::WebAuthnMakeCredentialInfo WebAuthnMakeCredentialInfo;
    typedef mozilla::dom::WebAuthnMakeCredentialResult WebAuthnMakeCredentialResult;
    typedef mozilla::dom::WebAuthnScopedCredential WebAuthnScopedCredential;
    typedef mozilla::ipc::PBackgroundParent PBackgroundParent;
    typedef mozilla::ipc::PBackgroundChild PBackgroundChild;

    typedef PWebAuthnTransaction::State State;

protected:
    virtual mozilla::ipc::IPCResult
    RecvRequestRegister(
            const uint64_t& aTransactionId,
            const WebAuthnMakeCredentialInfo& aTransactionInfo) = 0;
    virtual mozilla::ipc::IPCResult
    RecvRequestSign(
            const uint64_t& aTransactionId,
            const WebAuthnGetAssertionInfo& aTransactionInfo) = 0;
    virtual mozilla::ipc::IPCResult
    RecvRequestCancel(const uint64_t& aTransactionId) = 0;
    virtual mozilla::ipc::IPCResult
    RecvDestroyMe() = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PWebAuthnTransactionParent();

    virtual ~PWebAuthnTransactionParent();

    PBackgroundParent*
    Manager() const;

    MOZ_MUST_USE static bool
    Send__delete__(PWebAuthnTransactionParent* actor);

    MOZ_MUST_USE bool
    SendConfirmRegister(
            const uint64_t& aTransactionId,
            const WebAuthnMakeCredentialResult& aResult);

    MOZ_MUST_USE bool
    SendConfirmSign(
            const uint64_t& aTransactionId,
            const WebAuthnGetAssertionResult& aResult);

    MOZ_MUST_USE bool
    SendAbort(
            const uint64_t& aTransactionId,
            const nsresult& Error);

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__) override;

    int32_t
    GetProtocolTypeId() override;

private:
    const char*
    ProtocolName() const override;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            PickleIterator* iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const nsTArray<WebAuthnScopedCredential>& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            nsTArray<WebAuthnScopedCredential>* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const WebAuthnMakeCredentialResult& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            WebAuthnMakeCredentialResult* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const WebAuthnExtensionAppId& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            WebAuthnExtensionAppId* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const nsTArray<WebAuthnExtension>& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            nsTArray<WebAuthnExtension>* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const WebAuthnExtensionResultAppId& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            WebAuthnExtensionResultAppId* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const WebAuthnScopedCredential& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            WebAuthnScopedCredential* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const PWebAuthnTransactionParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PWebAuthnTransactionParent** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    void
    Write(
            const WebAuthnMakeCredentialInfo& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            WebAuthnMakeCredentialInfo* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const WebAuthnExtension& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            WebAuthnExtension* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const WebAuthnGetAssertionInfo& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            WebAuthnGetAssertionInfo* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const nsTArray<WebAuthnExtensionResult>& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            nsTArray<WebAuthnExtensionResult>* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const WebAuthnAuthenticatorSelection& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            WebAuthnAuthenticatorSelection* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const WebAuthnExtensionResult& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            WebAuthnExtensionResult* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const WebAuthnGetAssertionResult& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            WebAuthnGetAssertionResult* v__,
            const Message* msg__,
            PickleIterator* iter__);

    State mState;
};


} // namespace dom
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace dom {
class WebAuthnTransactionParent :
    public PWebAuthnTransactionParent
{
    mozilla::ipc::IPCResult
    RecvRequestRegister(
            const uint64_t& aTransactionId,
            const WebAuthnMakeCredentialInfo& aTransactionInfo) override;

    mozilla::ipc::IPCResult
    RecvRequestSign(
            const uint64_t& aTransactionId,
            const WebAuthnGetAssertionInfo& aTransactionInfo) override;

    mozilla::ipc::IPCResult
    RecvRequestCancel(const uint64_t& aTransactionId) override;

    mozilla::ipc::IPCResult
    RecvDestroyMe() override;

    void
    ActorDestroy(ActorDestroyReason aWhy) override;

    MOZ_IMPLICIT WebAuthnTransactionParent();
    virtual ~WebAuthnTransactionParent();
};
} // namespace dom
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace dom {
mozilla::ipc::IPCResult
WebAuthnTransactionParent::RecvRequestRegister(
        const uint64_t& aTransactionId,
        const WebAuthnMakeCredentialInfo& aTransactionInfo)
{
}

mozilla::ipc::IPCResult
WebAuthnTransactionParent::RecvRequestSign(
        const uint64_t& aTransactionId,
        const WebAuthnGetAssertionInfo& aTransactionInfo)
{
}

mozilla::ipc::IPCResult
WebAuthnTransactionParent::RecvRequestCancel(const uint64_t& aTransactionId)
{
}

mozilla::ipc::IPCResult
WebAuthnTransactionParent::RecvDestroyMe()
{
}

void
WebAuthnTransactionParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT WebAuthnTransactionParent::WebAuthnTransactionParent()
{
    MOZ_COUNT_CTOR(WebAuthnTransactionParent);
}

MOZ_IMPLICIT WebAuthnTransactionParent::~WebAuthnTransactionParent()
{
    MOZ_COUNT_DTOR(WebAuthnTransactionParent);
}

} // namespace dom
} // namespace mozilla
#endif // if 0

#endif // ifndef PWebAuthnTransactionParent_h
