//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/jsipc/JavaScriptTypes.h"


//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct JSIID|
//
namespace mozilla {
namespace jsipc {
auto JSIID::operator==(const JSIID& _o) const -> bool
{
    if ((!((m0()) == ((_o).m0())))) {
        return false;
    }
    if ((!((m1()) == ((_o).m1())))) {
        return false;
    }
    if ((!((m2()) == ((_o).m2())))) {
        return false;
    }
    if ((!((m3_0()) == ((_o).m3_0())))) {
        return false;
    }
    if ((!((m3_1()) == ((_o).m3_1())))) {
        return false;
    }
    if ((!((m3_2()) == ((_o).m3_2())))) {
        return false;
    }
    if ((!((m3_3()) == ((_o).m3_3())))) {
        return false;
    }
    if ((!((m3_4()) == ((_o).m3_4())))) {
        return false;
    }
    if ((!((m3_5()) == ((_o).m3_5())))) {
        return false;
    }
    if ((!((m3_6()) == ((_o).m3_6())))) {
        return false;
    }
    if ((!((m3_7()) == ((_o).m3_7())))) {
        return false;
    }
    return true;
}

auto JSIID::operator!=(const JSIID& _o) const -> bool
{
    return (!(operator==(_o)));
}

} // namespace jsipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct LocalObject|
//
namespace mozilla {
namespace jsipc {
auto LocalObject::operator==(const LocalObject& _o) const -> bool
{
    if ((!((serializedId()) == ((_o).serializedId())))) {
        return false;
    }
    return true;
}

auto LocalObject::operator!=(const LocalObject& _o) const -> bool
{
    return (!(operator==(_o)));
}

} // namespace jsipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct RemoteObject|
//
namespace mozilla {
namespace jsipc {
auto RemoteObject::operator==(const RemoteObject& _o) const -> bool
{
    if ((!((serializedId()) == ((_o).serializedId())))) {
        return false;
    }
    if ((!((isCallable()) == ((_o).isCallable())))) {
        return false;
    }
    if ((!((isConstructor()) == ((_o).isConstructor())))) {
        return false;
    }
    if ((!((isDOMObject()) == ((_o).isDOMObject())))) {
        return false;
    }
    if ((!((objectTag()) == ((_o).objectTag())))) {
        return false;
    }
    return true;
}

auto RemoteObject::operator!=(const RemoteObject& _o) const -> bool
{
    return (!(operator==(_o)));
}

} // namespace jsipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |union ObjectVariant|
//
namespace mozilla {
namespace jsipc {
auto ObjectVariant::MaybeDestroy(Type aNewType) -> bool
{
    if ((mType) == (T__None)) {
        return true;
    }
    if ((mType) == (aNewType)) {
        return false;
    }
    switch (mType) {
    case TLocalObject:
        {
            (ptr_LocalObject())->~LocalObject__tdef();
            break;
        }
    case TRemoteObject:
        {
            (ptr_RemoteObject())->~RemoteObject__tdef();
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("not reached");
            break;
        }
    }
    return true;
}

MOZ_IMPLICIT ObjectVariant::ObjectVariant(const LocalObject& aOther)
{
    new (mozilla::KnownNotNull, ptr_LocalObject()) LocalObject(aOther);
    mType = TLocalObject;
}

MOZ_IMPLICIT ObjectVariant::ObjectVariant(LocalObject&& aOther)
{
    new (mozilla::KnownNotNull, ptr_LocalObject()) LocalObject(mozilla::Move(aOther));
    mType = TLocalObject;
}

MOZ_IMPLICIT ObjectVariant::ObjectVariant(const RemoteObject& aOther)
{
    new (mozilla::KnownNotNull, ptr_RemoteObject()) RemoteObject(aOther);
    mType = TRemoteObject;
}

MOZ_IMPLICIT ObjectVariant::ObjectVariant(RemoteObject&& aOther)
{
    new (mozilla::KnownNotNull, ptr_RemoteObject()) RemoteObject(mozilla::Move(aOther));
    mType = TRemoteObject;
}

MOZ_IMPLICIT ObjectVariant::ObjectVariant(const ObjectVariant& aOther)
{
    (aOther).AssertSanity();
    switch ((aOther).type()) {
    case TLocalObject:
        {
            new (mozilla::KnownNotNull, ptr_LocalObject()) LocalObject((aOther).get_LocalObject());
            break;
        }
    case TRemoteObject:
        {
            new (mozilla::KnownNotNull, ptr_RemoteObject()) RemoteObject((aOther).get_RemoteObject());
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    mType = (aOther).type();
}

MOZ_IMPLICIT ObjectVariant::ObjectVariant(ObjectVariant&& aOther)
{
    (aOther).AssertSanity();
    Type t = (aOther).type();
    switch (t) {
    case TLocalObject:
        {
            new (mozilla::KnownNotNull, ptr_LocalObject()) LocalObject(mozilla::Move((aOther).get_LocalObject()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case TRemoteObject:
        {
            new (mozilla::KnownNotNull, ptr_RemoteObject()) RemoteObject(mozilla::Move((aOther).get_RemoteObject()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    (aOther).mType = T__None;
    mType = t;
}

ObjectVariant::~ObjectVariant()
{
    static_cast<void>(MaybeDestroy(T__None));
}

auto ObjectVariant::operator=(const LocalObject& aRhs) -> ObjectVariant&
{
    if (MaybeDestroy(TLocalObject)) {
        new (mozilla::KnownNotNull, ptr_LocalObject()) LocalObject;
    }
    (*(ptr_LocalObject())) = aRhs;
    mType = TLocalObject;
    return (*(this));
}

auto ObjectVariant::operator=(LocalObject&& aRhs) -> ObjectVariant&
{
    if (MaybeDestroy(TLocalObject)) {
        new (mozilla::KnownNotNull, ptr_LocalObject()) LocalObject;
    }
    (*(ptr_LocalObject())) = mozilla::Move(aRhs);
    mType = TLocalObject;
    return (*(this));
}

auto ObjectVariant::operator=(const RemoteObject& aRhs) -> ObjectVariant&
{
    if (MaybeDestroy(TRemoteObject)) {
        new (mozilla::KnownNotNull, ptr_RemoteObject()) RemoteObject;
    }
    (*(ptr_RemoteObject())) = aRhs;
    mType = TRemoteObject;
    return (*(this));
}

auto ObjectVariant::operator=(RemoteObject&& aRhs) -> ObjectVariant&
{
    if (MaybeDestroy(TRemoteObject)) {
        new (mozilla::KnownNotNull, ptr_RemoteObject()) RemoteObject;
    }
    (*(ptr_RemoteObject())) = mozilla::Move(aRhs);
    mType = TRemoteObject;
    return (*(this));
}

auto ObjectVariant::operator=(const ObjectVariant& aRhs) -> ObjectVariant&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TLocalObject:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_LocalObject()) LocalObject;
            }
            (*(ptr_LocalObject())) = (aRhs).get_LocalObject();
            break;
        }
    case TRemoteObject:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_RemoteObject()) RemoteObject;
            }
            (*(ptr_RemoteObject())) = (aRhs).get_RemoteObject();
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    mType = t;
    return (*(this));
}

auto ObjectVariant::operator=(ObjectVariant&& aRhs) -> ObjectVariant&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TLocalObject:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_LocalObject()) LocalObject;
            }
            (*(ptr_LocalObject())) = mozilla::Move((aRhs).get_LocalObject());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case TRemoteObject:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_RemoteObject()) RemoteObject;
            }
            (*(ptr_RemoteObject())) = mozilla::Move((aRhs).get_RemoteObject());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    (aRhs).mType = T__None;
    mType = t;
    return (*(this));
}

auto ObjectVariant::operator==(const LocalObject& aRhs) const -> bool
{
    return (get_LocalObject()) == (aRhs);
}

auto ObjectVariant::operator==(const RemoteObject& aRhs) const -> bool
{
    return (get_RemoteObject()) == (aRhs);
}

auto ObjectVariant::operator==(const ObjectVariant& aRhs) const -> bool
{
    if ((type()) != ((aRhs).type())) {
        return false;
    }

    switch (type()) {
    case TLocalObject:
        {
            return (get_LocalObject()) == ((aRhs).get_LocalObject());
        }
    case TRemoteObject:
        {
            return (get_RemoteObject()) == ((aRhs).get_RemoteObject());
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return false;
        }
    }
}

auto ObjectVariant::get(LocalObject* aOutValue) const -> void
{
    (*(aOutValue)) = get_LocalObject();
}

auto ObjectVariant::get(RemoteObject* aOutValue) const -> void
{
    (*(aOutValue)) = get_RemoteObject();
}

} // namespace jsipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct WellKnownSymbol|
//
namespace mozilla {
namespace jsipc {
auto WellKnownSymbol::operator==(const WellKnownSymbol& _o) const -> bool
{
    if ((!((which()) == ((_o).which())))) {
        return false;
    }
    return true;
}

auto WellKnownSymbol::operator!=(const WellKnownSymbol& _o) const -> bool
{
    return (!(operator==(_o)));
}

} // namespace jsipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct RegisteredSymbol|
//
namespace mozilla {
namespace jsipc {
auto RegisteredSymbol::operator==(const RegisteredSymbol& _o) const -> bool
{
    if ((!((key()) == ((_o).key())))) {
        return false;
    }
    return true;
}

auto RegisteredSymbol::operator!=(const RegisteredSymbol& _o) const -> bool
{
    return (!(operator==(_o)));
}

} // namespace jsipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |union SymbolVariant|
//
namespace mozilla {
namespace jsipc {
auto SymbolVariant::MaybeDestroy(Type aNewType) -> bool
{
    if ((mType) == (T__None)) {
        return true;
    }
    if ((mType) == (aNewType)) {
        return false;
    }
    switch (mType) {
    case TWellKnownSymbol:
        {
            (ptr_WellKnownSymbol())->~WellKnownSymbol__tdef();
            break;
        }
    case TRegisteredSymbol:
        {
            (ptr_RegisteredSymbol())->~RegisteredSymbol__tdef();
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("not reached");
            break;
        }
    }
    return true;
}

MOZ_IMPLICIT SymbolVariant::SymbolVariant(const WellKnownSymbol& aOther)
{
    new (mozilla::KnownNotNull, ptr_WellKnownSymbol()) WellKnownSymbol(aOther);
    mType = TWellKnownSymbol;
}

MOZ_IMPLICIT SymbolVariant::SymbolVariant(WellKnownSymbol&& aOther)
{
    new (mozilla::KnownNotNull, ptr_WellKnownSymbol()) WellKnownSymbol(mozilla::Move(aOther));
    mType = TWellKnownSymbol;
}

MOZ_IMPLICIT SymbolVariant::SymbolVariant(const RegisteredSymbol& aOther)
{
    new (mozilla::KnownNotNull, ptr_RegisteredSymbol()) RegisteredSymbol(aOther);
    mType = TRegisteredSymbol;
}

MOZ_IMPLICIT SymbolVariant::SymbolVariant(RegisteredSymbol&& aOther)
{
    new (mozilla::KnownNotNull, ptr_RegisteredSymbol()) RegisteredSymbol(mozilla::Move(aOther));
    mType = TRegisteredSymbol;
}

MOZ_IMPLICIT SymbolVariant::SymbolVariant(const SymbolVariant& aOther)
{
    (aOther).AssertSanity();
    switch ((aOther).type()) {
    case TWellKnownSymbol:
        {
            new (mozilla::KnownNotNull, ptr_WellKnownSymbol()) WellKnownSymbol((aOther).get_WellKnownSymbol());
            break;
        }
    case TRegisteredSymbol:
        {
            new (mozilla::KnownNotNull, ptr_RegisteredSymbol()) RegisteredSymbol((aOther).get_RegisteredSymbol());
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    mType = (aOther).type();
}

MOZ_IMPLICIT SymbolVariant::SymbolVariant(SymbolVariant&& aOther)
{
    (aOther).AssertSanity();
    Type t = (aOther).type();
    switch (t) {
    case TWellKnownSymbol:
        {
            new (mozilla::KnownNotNull, ptr_WellKnownSymbol()) WellKnownSymbol(mozilla::Move((aOther).get_WellKnownSymbol()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case TRegisteredSymbol:
        {
            new (mozilla::KnownNotNull, ptr_RegisteredSymbol()) RegisteredSymbol(mozilla::Move((aOther).get_RegisteredSymbol()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    (aOther).mType = T__None;
    mType = t;
}

SymbolVariant::~SymbolVariant()
{
    static_cast<void>(MaybeDestroy(T__None));
}

auto SymbolVariant::operator=(const WellKnownSymbol& aRhs) -> SymbolVariant&
{
    if (MaybeDestroy(TWellKnownSymbol)) {
        new (mozilla::KnownNotNull, ptr_WellKnownSymbol()) WellKnownSymbol;
    }
    (*(ptr_WellKnownSymbol())) = aRhs;
    mType = TWellKnownSymbol;
    return (*(this));
}

auto SymbolVariant::operator=(WellKnownSymbol&& aRhs) -> SymbolVariant&
{
    if (MaybeDestroy(TWellKnownSymbol)) {
        new (mozilla::KnownNotNull, ptr_WellKnownSymbol()) WellKnownSymbol;
    }
    (*(ptr_WellKnownSymbol())) = mozilla::Move(aRhs);
    mType = TWellKnownSymbol;
    return (*(this));
}

auto SymbolVariant::operator=(const RegisteredSymbol& aRhs) -> SymbolVariant&
{
    if (MaybeDestroy(TRegisteredSymbol)) {
        new (mozilla::KnownNotNull, ptr_RegisteredSymbol()) RegisteredSymbol;
    }
    (*(ptr_RegisteredSymbol())) = aRhs;
    mType = TRegisteredSymbol;
    return (*(this));
}

auto SymbolVariant::operator=(RegisteredSymbol&& aRhs) -> SymbolVariant&
{
    if (MaybeDestroy(TRegisteredSymbol)) {
        new (mozilla::KnownNotNull, ptr_RegisteredSymbol()) RegisteredSymbol;
    }
    (*(ptr_RegisteredSymbol())) = mozilla::Move(aRhs);
    mType = TRegisteredSymbol;
    return (*(this));
}

auto SymbolVariant::operator=(const SymbolVariant& aRhs) -> SymbolVariant&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TWellKnownSymbol:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_WellKnownSymbol()) WellKnownSymbol;
            }
            (*(ptr_WellKnownSymbol())) = (aRhs).get_WellKnownSymbol();
            break;
        }
    case TRegisteredSymbol:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_RegisteredSymbol()) RegisteredSymbol;
            }
            (*(ptr_RegisteredSymbol())) = (aRhs).get_RegisteredSymbol();
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    mType = t;
    return (*(this));
}

auto SymbolVariant::operator=(SymbolVariant&& aRhs) -> SymbolVariant&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TWellKnownSymbol:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_WellKnownSymbol()) WellKnownSymbol;
            }
            (*(ptr_WellKnownSymbol())) = mozilla::Move((aRhs).get_WellKnownSymbol());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case TRegisteredSymbol:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_RegisteredSymbol()) RegisteredSymbol;
            }
            (*(ptr_RegisteredSymbol())) = mozilla::Move((aRhs).get_RegisteredSymbol());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    (aRhs).mType = T__None;
    mType = t;
    return (*(this));
}

auto SymbolVariant::operator==(const WellKnownSymbol& aRhs) const -> bool
{
    return (get_WellKnownSymbol()) == (aRhs);
}

auto SymbolVariant::operator==(const RegisteredSymbol& aRhs) const -> bool
{
    return (get_RegisteredSymbol()) == (aRhs);
}

auto SymbolVariant::operator==(const SymbolVariant& aRhs) const -> bool
{
    if ((type()) != ((aRhs).type())) {
        return false;
    }

    switch (type()) {
    case TWellKnownSymbol:
        {
            return (get_WellKnownSymbol()) == ((aRhs).get_WellKnownSymbol());
        }
    case TRegisteredSymbol:
        {
            return (get_RegisteredSymbol()) == ((aRhs).get_RegisteredSymbol());
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return false;
        }
    }
}

auto SymbolVariant::get(WellKnownSymbol* aOutValue) const -> void
{
    (*(aOutValue)) = get_WellKnownSymbol();
}

auto SymbolVariant::get(RegisteredSymbol* aOutValue) const -> void
{
    (*(aOutValue)) = get_RegisteredSymbol();
}

} // namespace jsipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct UndefinedVariant|
//
namespace mozilla {
namespace jsipc {
auto UndefinedVariant::operator==(const UndefinedVariant& _o) const -> bool
{
    return true;
}

auto UndefinedVariant::operator!=(const UndefinedVariant& _o) const -> bool
{
    return (!(operator==(_o)));
}

} // namespace jsipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct NullVariant|
//
namespace mozilla {
namespace jsipc {
auto NullVariant::operator==(const NullVariant& _o) const -> bool
{
    return true;
}

auto NullVariant::operator!=(const NullVariant& _o) const -> bool
{
    return (!(operator==(_o)));
}

} // namespace jsipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |union ObjectOrNullVariant|
//
namespace mozilla {
namespace jsipc {
auto ObjectOrNullVariant::MaybeDestroy(Type aNewType) -> bool
{
    if ((mType) == (T__None)) {
        return true;
    }
    if ((mType) == (aNewType)) {
        return false;
    }
    switch (mType) {
    case TObjectVariant:
        {
            (ptr_ObjectVariant())->~ObjectVariant__tdef();
            break;
        }
    case TNullVariant:
        {
            (ptr_NullVariant())->~NullVariant__tdef();
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("not reached");
            break;
        }
    }
    return true;
}

MOZ_IMPLICIT ObjectOrNullVariant::ObjectOrNullVariant(const ObjectVariant& aOther)
{
    new (mozilla::KnownNotNull, ptr_ObjectVariant()) ObjectVariant(aOther);
    mType = TObjectVariant;
}

MOZ_IMPLICIT ObjectOrNullVariant::ObjectOrNullVariant(ObjectVariant&& aOther)
{
    new (mozilla::KnownNotNull, ptr_ObjectVariant()) ObjectVariant(mozilla::Move(aOther));
    mType = TObjectVariant;
}

MOZ_IMPLICIT ObjectOrNullVariant::ObjectOrNullVariant(const NullVariant& aOther)
{
    new (mozilla::KnownNotNull, ptr_NullVariant()) NullVariant(aOther);
    mType = TNullVariant;
}

MOZ_IMPLICIT ObjectOrNullVariant::ObjectOrNullVariant(NullVariant&& aOther)
{
    new (mozilla::KnownNotNull, ptr_NullVariant()) NullVariant(mozilla::Move(aOther));
    mType = TNullVariant;
}

MOZ_IMPLICIT ObjectOrNullVariant::ObjectOrNullVariant(const ObjectOrNullVariant& aOther)
{
    (aOther).AssertSanity();
    switch ((aOther).type()) {
    case TObjectVariant:
        {
            new (mozilla::KnownNotNull, ptr_ObjectVariant()) ObjectVariant((aOther).get_ObjectVariant());
            break;
        }
    case TNullVariant:
        {
            new (mozilla::KnownNotNull, ptr_NullVariant()) NullVariant((aOther).get_NullVariant());
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    mType = (aOther).type();
}

MOZ_IMPLICIT ObjectOrNullVariant::ObjectOrNullVariant(ObjectOrNullVariant&& aOther)
{
    (aOther).AssertSanity();
    Type t = (aOther).type();
    switch (t) {
    case TObjectVariant:
        {
            new (mozilla::KnownNotNull, ptr_ObjectVariant()) ObjectVariant(mozilla::Move((aOther).get_ObjectVariant()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case TNullVariant:
        {
            new (mozilla::KnownNotNull, ptr_NullVariant()) NullVariant(mozilla::Move((aOther).get_NullVariant()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    (aOther).mType = T__None;
    mType = t;
}

ObjectOrNullVariant::~ObjectOrNullVariant()
{
    static_cast<void>(MaybeDestroy(T__None));
}

auto ObjectOrNullVariant::operator=(const ObjectVariant& aRhs) -> ObjectOrNullVariant&
{
    if (MaybeDestroy(TObjectVariant)) {
        new (mozilla::KnownNotNull, ptr_ObjectVariant()) ObjectVariant;
    }
    (*(ptr_ObjectVariant())) = aRhs;
    mType = TObjectVariant;
    return (*(this));
}

auto ObjectOrNullVariant::operator=(ObjectVariant&& aRhs) -> ObjectOrNullVariant&
{
    if (MaybeDestroy(TObjectVariant)) {
        new (mozilla::KnownNotNull, ptr_ObjectVariant()) ObjectVariant;
    }
    (*(ptr_ObjectVariant())) = mozilla::Move(aRhs);
    mType = TObjectVariant;
    return (*(this));
}

auto ObjectOrNullVariant::operator=(const NullVariant& aRhs) -> ObjectOrNullVariant&
{
    if (MaybeDestroy(TNullVariant)) {
        new (mozilla::KnownNotNull, ptr_NullVariant()) NullVariant;
    }
    (*(ptr_NullVariant())) = aRhs;
    mType = TNullVariant;
    return (*(this));
}

auto ObjectOrNullVariant::operator=(NullVariant&& aRhs) -> ObjectOrNullVariant&
{
    if (MaybeDestroy(TNullVariant)) {
        new (mozilla::KnownNotNull, ptr_NullVariant()) NullVariant;
    }
    (*(ptr_NullVariant())) = mozilla::Move(aRhs);
    mType = TNullVariant;
    return (*(this));
}

auto ObjectOrNullVariant::operator=(const ObjectOrNullVariant& aRhs) -> ObjectOrNullVariant&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TObjectVariant:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_ObjectVariant()) ObjectVariant;
            }
            (*(ptr_ObjectVariant())) = (aRhs).get_ObjectVariant();
            break;
        }
    case TNullVariant:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_NullVariant()) NullVariant;
            }
            (*(ptr_NullVariant())) = (aRhs).get_NullVariant();
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    mType = t;
    return (*(this));
}

auto ObjectOrNullVariant::operator=(ObjectOrNullVariant&& aRhs) -> ObjectOrNullVariant&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TObjectVariant:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_ObjectVariant()) ObjectVariant;
            }
            (*(ptr_ObjectVariant())) = mozilla::Move((aRhs).get_ObjectVariant());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case TNullVariant:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_NullVariant()) NullVariant;
            }
            (*(ptr_NullVariant())) = mozilla::Move((aRhs).get_NullVariant());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    (aRhs).mType = T__None;
    mType = t;
    return (*(this));
}

auto ObjectOrNullVariant::operator==(const ObjectVariant& aRhs) const -> bool
{
    return (get_ObjectVariant()) == (aRhs);
}

auto ObjectOrNullVariant::operator==(const NullVariant& aRhs) const -> bool
{
    return (get_NullVariant()) == (aRhs);
}

auto ObjectOrNullVariant::operator==(const ObjectOrNullVariant& aRhs) const -> bool
{
    if ((type()) != ((aRhs).type())) {
        return false;
    }

    switch (type()) {
    case TObjectVariant:
        {
            return (get_ObjectVariant()) == ((aRhs).get_ObjectVariant());
        }
    case TNullVariant:
        {
            return (get_NullVariant()) == ((aRhs).get_NullVariant());
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return false;
        }
    }
}

auto ObjectOrNullVariant::get(ObjectVariant* aOutValue) const -> void
{
    (*(aOutValue)) = get_ObjectVariant();
}

auto ObjectOrNullVariant::get(NullVariant* aOutValue) const -> void
{
    (*(aOutValue)) = get_NullVariant();
}

} // namespace jsipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |union JSVariant|
//
namespace mozilla {
namespace jsipc {
auto JSVariant::MaybeDestroy(Type aNewType) -> bool
{
    if ((mType) == (T__None)) {
        return true;
    }
    if ((mType) == (aNewType)) {
        return false;
    }
    switch (mType) {
    case TUndefinedVariant:
        {
            (ptr_UndefinedVariant())->~UndefinedVariant__tdef();
            break;
        }
    case TNullVariant:
        {
            (ptr_NullVariant())->~NullVariant__tdef();
            break;
        }
    case TObjectVariant:
        {
            (ptr_ObjectVariant())->~ObjectVariant__tdef();
            break;
        }
    case TSymbolVariant:
        {
            (ptr_SymbolVariant())->~SymbolVariant__tdef();
            break;
        }
    case TnsString:
        {
            (ptr_nsString())->~nsString__tdef();
            break;
        }
    case Tdouble:
        {
            (ptr_double())->~double__tdef();
            break;
        }
    case Tbool:
        {
            (ptr_bool())->~bool__tdef();
            break;
        }
    case TJSIID:
        {
            (ptr_JSIID())->~JSIID__tdef();
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("not reached");
            break;
        }
    }
    return true;
}

MOZ_IMPLICIT JSVariant::JSVariant(const UndefinedVariant& aOther)
{
    new (mozilla::KnownNotNull, ptr_UndefinedVariant()) UndefinedVariant(aOther);
    mType = TUndefinedVariant;
}

MOZ_IMPLICIT JSVariant::JSVariant(UndefinedVariant&& aOther)
{
    new (mozilla::KnownNotNull, ptr_UndefinedVariant()) UndefinedVariant(mozilla::Move(aOther));
    mType = TUndefinedVariant;
}

MOZ_IMPLICIT JSVariant::JSVariant(const NullVariant& aOther)
{
    new (mozilla::KnownNotNull, ptr_NullVariant()) NullVariant(aOther);
    mType = TNullVariant;
}

MOZ_IMPLICIT JSVariant::JSVariant(NullVariant&& aOther)
{
    new (mozilla::KnownNotNull, ptr_NullVariant()) NullVariant(mozilla::Move(aOther));
    mType = TNullVariant;
}

MOZ_IMPLICIT JSVariant::JSVariant(const ObjectVariant& aOther)
{
    new (mozilla::KnownNotNull, ptr_ObjectVariant()) ObjectVariant(aOther);
    mType = TObjectVariant;
}

MOZ_IMPLICIT JSVariant::JSVariant(ObjectVariant&& aOther)
{
    new (mozilla::KnownNotNull, ptr_ObjectVariant()) ObjectVariant(mozilla::Move(aOther));
    mType = TObjectVariant;
}

MOZ_IMPLICIT JSVariant::JSVariant(const SymbolVariant& aOther)
{
    new (mozilla::KnownNotNull, ptr_SymbolVariant()) SymbolVariant(aOther);
    mType = TSymbolVariant;
}

MOZ_IMPLICIT JSVariant::JSVariant(SymbolVariant&& aOther)
{
    new (mozilla::KnownNotNull, ptr_SymbolVariant()) SymbolVariant(mozilla::Move(aOther));
    mType = TSymbolVariant;
}

MOZ_IMPLICIT JSVariant::JSVariant(const nsString& aOther)
{
    new (mozilla::KnownNotNull, ptr_nsString()) nsString(aOther);
    mType = TnsString;
}

MOZ_IMPLICIT JSVariant::JSVariant(nsString&& aOther)
{
    new (mozilla::KnownNotNull, ptr_nsString()) nsString(mozilla::Move(aOther));
    mType = TnsString;
}

MOZ_IMPLICIT JSVariant::JSVariant(const double& aOther)
{
    new (mozilla::KnownNotNull, ptr_double()) double(aOther);
    mType = Tdouble;
}

MOZ_IMPLICIT JSVariant::JSVariant(double&& aOther)
{
    new (mozilla::KnownNotNull, ptr_double()) double(mozilla::Move(aOther));
    mType = Tdouble;
}

MOZ_IMPLICIT JSVariant::JSVariant(const bool& aOther)
{
    new (mozilla::KnownNotNull, ptr_bool()) bool(aOther);
    mType = Tbool;
}

MOZ_IMPLICIT JSVariant::JSVariant(bool&& aOther)
{
    new (mozilla::KnownNotNull, ptr_bool()) bool(mozilla::Move(aOther));
    mType = Tbool;
}

MOZ_IMPLICIT JSVariant::JSVariant(const JSIID& aOther)
{
    new (mozilla::KnownNotNull, ptr_JSIID()) JSIID(aOther);
    mType = TJSIID;
}

MOZ_IMPLICIT JSVariant::JSVariant(JSIID&& aOther)
{
    new (mozilla::KnownNotNull, ptr_JSIID()) JSIID(mozilla::Move(aOther));
    mType = TJSIID;
}

MOZ_IMPLICIT JSVariant::JSVariant(const JSVariant& aOther)
{
    (aOther).AssertSanity();
    switch ((aOther).type()) {
    case TUndefinedVariant:
        {
            new (mozilla::KnownNotNull, ptr_UndefinedVariant()) UndefinedVariant((aOther).get_UndefinedVariant());
            break;
        }
    case TNullVariant:
        {
            new (mozilla::KnownNotNull, ptr_NullVariant()) NullVariant((aOther).get_NullVariant());
            break;
        }
    case TObjectVariant:
        {
            new (mozilla::KnownNotNull, ptr_ObjectVariant()) ObjectVariant((aOther).get_ObjectVariant());
            break;
        }
    case TSymbolVariant:
        {
            new (mozilla::KnownNotNull, ptr_SymbolVariant()) SymbolVariant((aOther).get_SymbolVariant());
            break;
        }
    case TnsString:
        {
            new (mozilla::KnownNotNull, ptr_nsString()) nsString((aOther).get_nsString());
            break;
        }
    case Tdouble:
        {
            new (mozilla::KnownNotNull, ptr_double()) double((aOther).get_double());
            break;
        }
    case Tbool:
        {
            new (mozilla::KnownNotNull, ptr_bool()) bool((aOther).get_bool());
            break;
        }
    case TJSIID:
        {
            new (mozilla::KnownNotNull, ptr_JSIID()) JSIID((aOther).get_JSIID());
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    mType = (aOther).type();
}

MOZ_IMPLICIT JSVariant::JSVariant(JSVariant&& aOther)
{
    (aOther).AssertSanity();
    Type t = (aOther).type();
    switch (t) {
    case TUndefinedVariant:
        {
            new (mozilla::KnownNotNull, ptr_UndefinedVariant()) UndefinedVariant(mozilla::Move((aOther).get_UndefinedVariant()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case TNullVariant:
        {
            new (mozilla::KnownNotNull, ptr_NullVariant()) NullVariant(mozilla::Move((aOther).get_NullVariant()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case TObjectVariant:
        {
            new (mozilla::KnownNotNull, ptr_ObjectVariant()) ObjectVariant(mozilla::Move((aOther).get_ObjectVariant()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case TSymbolVariant:
        {
            new (mozilla::KnownNotNull, ptr_SymbolVariant()) SymbolVariant(mozilla::Move((aOther).get_SymbolVariant()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case TnsString:
        {
            new (mozilla::KnownNotNull, ptr_nsString()) nsString(mozilla::Move((aOther).get_nsString()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case Tdouble:
        {
            new (mozilla::KnownNotNull, ptr_double()) double(mozilla::Move((aOther).get_double()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case Tbool:
        {
            new (mozilla::KnownNotNull, ptr_bool()) bool(mozilla::Move((aOther).get_bool()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case TJSIID:
        {
            new (mozilla::KnownNotNull, ptr_JSIID()) JSIID(mozilla::Move((aOther).get_JSIID()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    (aOther).mType = T__None;
    mType = t;
}

JSVariant::~JSVariant()
{
    static_cast<void>(MaybeDestroy(T__None));
}

auto JSVariant::operator=(const UndefinedVariant& aRhs) -> JSVariant&
{
    if (MaybeDestroy(TUndefinedVariant)) {
        new (mozilla::KnownNotNull, ptr_UndefinedVariant()) UndefinedVariant;
    }
    (*(ptr_UndefinedVariant())) = aRhs;
    mType = TUndefinedVariant;
    return (*(this));
}

auto JSVariant::operator=(UndefinedVariant&& aRhs) -> JSVariant&
{
    if (MaybeDestroy(TUndefinedVariant)) {
        new (mozilla::KnownNotNull, ptr_UndefinedVariant()) UndefinedVariant;
    }
    (*(ptr_UndefinedVariant())) = mozilla::Move(aRhs);
    mType = TUndefinedVariant;
    return (*(this));
}

auto JSVariant::operator=(const NullVariant& aRhs) -> JSVariant&
{
    if (MaybeDestroy(TNullVariant)) {
        new (mozilla::KnownNotNull, ptr_NullVariant()) NullVariant;
    }
    (*(ptr_NullVariant())) = aRhs;
    mType = TNullVariant;
    return (*(this));
}

auto JSVariant::operator=(NullVariant&& aRhs) -> JSVariant&
{
    if (MaybeDestroy(TNullVariant)) {
        new (mozilla::KnownNotNull, ptr_NullVariant()) NullVariant;
    }
    (*(ptr_NullVariant())) = mozilla::Move(aRhs);
    mType = TNullVariant;
    return (*(this));
}

auto JSVariant::operator=(const ObjectVariant& aRhs) -> JSVariant&
{
    if (MaybeDestroy(TObjectVariant)) {
        new (mozilla::KnownNotNull, ptr_ObjectVariant()) ObjectVariant;
    }
    (*(ptr_ObjectVariant())) = aRhs;
    mType = TObjectVariant;
    return (*(this));
}

auto JSVariant::operator=(ObjectVariant&& aRhs) -> JSVariant&
{
    if (MaybeDestroy(TObjectVariant)) {
        new (mozilla::KnownNotNull, ptr_ObjectVariant()) ObjectVariant;
    }
    (*(ptr_ObjectVariant())) = mozilla::Move(aRhs);
    mType = TObjectVariant;
    return (*(this));
}

auto JSVariant::operator=(const SymbolVariant& aRhs) -> JSVariant&
{
    if (MaybeDestroy(TSymbolVariant)) {
        new (mozilla::KnownNotNull, ptr_SymbolVariant()) SymbolVariant;
    }
    (*(ptr_SymbolVariant())) = aRhs;
    mType = TSymbolVariant;
    return (*(this));
}

auto JSVariant::operator=(SymbolVariant&& aRhs) -> JSVariant&
{
    if (MaybeDestroy(TSymbolVariant)) {
        new (mozilla::KnownNotNull, ptr_SymbolVariant()) SymbolVariant;
    }
    (*(ptr_SymbolVariant())) = mozilla::Move(aRhs);
    mType = TSymbolVariant;
    return (*(this));
}

auto JSVariant::operator=(const nsString& aRhs) -> JSVariant&
{
    if (MaybeDestroy(TnsString)) {
        new (mozilla::KnownNotNull, ptr_nsString()) nsString;
    }
    (*(ptr_nsString())) = aRhs;
    mType = TnsString;
    return (*(this));
}

auto JSVariant::operator=(nsString&& aRhs) -> JSVariant&
{
    if (MaybeDestroy(TnsString)) {
        new (mozilla::KnownNotNull, ptr_nsString()) nsString;
    }
    (*(ptr_nsString())) = mozilla::Move(aRhs);
    mType = TnsString;
    return (*(this));
}

auto JSVariant::operator=(const double& aRhs) -> JSVariant&
{
    if (MaybeDestroy(Tdouble)) {
        new (mozilla::KnownNotNull, ptr_double()) double;
    }
    (*(ptr_double())) = aRhs;
    mType = Tdouble;
    return (*(this));
}

auto JSVariant::operator=(double&& aRhs) -> JSVariant&
{
    if (MaybeDestroy(Tdouble)) {
        new (mozilla::KnownNotNull, ptr_double()) double;
    }
    (*(ptr_double())) = mozilla::Move(aRhs);
    mType = Tdouble;
    return (*(this));
}

auto JSVariant::operator=(const bool& aRhs) -> JSVariant&
{
    if (MaybeDestroy(Tbool)) {
        new (mozilla::KnownNotNull, ptr_bool()) bool;
    }
    (*(ptr_bool())) = aRhs;
    mType = Tbool;
    return (*(this));
}

auto JSVariant::operator=(bool&& aRhs) -> JSVariant&
{
    if (MaybeDestroy(Tbool)) {
        new (mozilla::KnownNotNull, ptr_bool()) bool;
    }
    (*(ptr_bool())) = mozilla::Move(aRhs);
    mType = Tbool;
    return (*(this));
}

auto JSVariant::operator=(const JSIID& aRhs) -> JSVariant&
{
    if (MaybeDestroy(TJSIID)) {
        new (mozilla::KnownNotNull, ptr_JSIID()) JSIID;
    }
    (*(ptr_JSIID())) = aRhs;
    mType = TJSIID;
    return (*(this));
}

auto JSVariant::operator=(JSIID&& aRhs) -> JSVariant&
{
    if (MaybeDestroy(TJSIID)) {
        new (mozilla::KnownNotNull, ptr_JSIID()) JSIID;
    }
    (*(ptr_JSIID())) = mozilla::Move(aRhs);
    mType = TJSIID;
    return (*(this));
}

auto JSVariant::operator=(const JSVariant& aRhs) -> JSVariant&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TUndefinedVariant:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_UndefinedVariant()) UndefinedVariant;
            }
            (*(ptr_UndefinedVariant())) = (aRhs).get_UndefinedVariant();
            break;
        }
    case TNullVariant:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_NullVariant()) NullVariant;
            }
            (*(ptr_NullVariant())) = (aRhs).get_NullVariant();
            break;
        }
    case TObjectVariant:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_ObjectVariant()) ObjectVariant;
            }
            (*(ptr_ObjectVariant())) = (aRhs).get_ObjectVariant();
            break;
        }
    case TSymbolVariant:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_SymbolVariant()) SymbolVariant;
            }
            (*(ptr_SymbolVariant())) = (aRhs).get_SymbolVariant();
            break;
        }
    case TnsString:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_nsString()) nsString;
            }
            (*(ptr_nsString())) = (aRhs).get_nsString();
            break;
        }
    case Tdouble:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_double()) double;
            }
            (*(ptr_double())) = (aRhs).get_double();
            break;
        }
    case Tbool:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_bool()) bool;
            }
            (*(ptr_bool())) = (aRhs).get_bool();
            break;
        }
    case TJSIID:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_JSIID()) JSIID;
            }
            (*(ptr_JSIID())) = (aRhs).get_JSIID();
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    mType = t;
    return (*(this));
}

auto JSVariant::operator=(JSVariant&& aRhs) -> JSVariant&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TUndefinedVariant:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_UndefinedVariant()) UndefinedVariant;
            }
            (*(ptr_UndefinedVariant())) = mozilla::Move((aRhs).get_UndefinedVariant());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case TNullVariant:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_NullVariant()) NullVariant;
            }
            (*(ptr_NullVariant())) = mozilla::Move((aRhs).get_NullVariant());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case TObjectVariant:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_ObjectVariant()) ObjectVariant;
            }
            (*(ptr_ObjectVariant())) = mozilla::Move((aRhs).get_ObjectVariant());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case TSymbolVariant:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_SymbolVariant()) SymbolVariant;
            }
            (*(ptr_SymbolVariant())) = mozilla::Move((aRhs).get_SymbolVariant());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case TnsString:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_nsString()) nsString;
            }
            (*(ptr_nsString())) = mozilla::Move((aRhs).get_nsString());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case Tdouble:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_double()) double;
            }
            (*(ptr_double())) = mozilla::Move((aRhs).get_double());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case Tbool:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_bool()) bool;
            }
            (*(ptr_bool())) = mozilla::Move((aRhs).get_bool());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case TJSIID:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_JSIID()) JSIID;
            }
            (*(ptr_JSIID())) = mozilla::Move((aRhs).get_JSIID());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    (aRhs).mType = T__None;
    mType = t;
    return (*(this));
}

auto JSVariant::operator==(const UndefinedVariant& aRhs) const -> bool
{
    return (get_UndefinedVariant()) == (aRhs);
}

auto JSVariant::operator==(const NullVariant& aRhs) const -> bool
{
    return (get_NullVariant()) == (aRhs);
}

auto JSVariant::operator==(const ObjectVariant& aRhs) const -> bool
{
    return (get_ObjectVariant()) == (aRhs);
}

auto JSVariant::operator==(const SymbolVariant& aRhs) const -> bool
{
    return (get_SymbolVariant()) == (aRhs);
}

auto JSVariant::operator==(const nsString& aRhs) const -> bool
{
    return (get_nsString()) == (aRhs);
}

auto JSVariant::operator==(const double& aRhs) const -> bool
{
    return (get_double()) == (aRhs);
}

auto JSVariant::operator==(const bool& aRhs) const -> bool
{
    return (get_bool()) == (aRhs);
}

auto JSVariant::operator==(const JSIID& aRhs) const -> bool
{
    return (get_JSIID()) == (aRhs);
}

auto JSVariant::operator==(const JSVariant& aRhs) const -> bool
{
    if ((type()) != ((aRhs).type())) {
        return false;
    }

    switch (type()) {
    case TUndefinedVariant:
        {
            return (get_UndefinedVariant()) == ((aRhs).get_UndefinedVariant());
        }
    case TNullVariant:
        {
            return (get_NullVariant()) == ((aRhs).get_NullVariant());
        }
    case TObjectVariant:
        {
            return (get_ObjectVariant()) == ((aRhs).get_ObjectVariant());
        }
    case TSymbolVariant:
        {
            return (get_SymbolVariant()) == ((aRhs).get_SymbolVariant());
        }
    case TnsString:
        {
            return (get_nsString()) == ((aRhs).get_nsString());
        }
    case Tdouble:
        {
            return (get_double()) == ((aRhs).get_double());
        }
    case Tbool:
        {
            return (get_bool()) == ((aRhs).get_bool());
        }
    case TJSIID:
        {
            return (get_JSIID()) == ((aRhs).get_JSIID());
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return false;
        }
    }
}

auto JSVariant::get(UndefinedVariant* aOutValue) const -> void
{
    (*(aOutValue)) = get_UndefinedVariant();
}

auto JSVariant::get(NullVariant* aOutValue) const -> void
{
    (*(aOutValue)) = get_NullVariant();
}

auto JSVariant::get(ObjectVariant* aOutValue) const -> void
{
    (*(aOutValue)) = get_ObjectVariant();
}

auto JSVariant::get(SymbolVariant* aOutValue) const -> void
{
    (*(aOutValue)) = get_SymbolVariant();
}

auto JSVariant::get(nsString* aOutValue) const -> void
{
    (*(aOutValue)) = get_nsString();
}

auto JSVariant::get(double* aOutValue) const -> void
{
    (*(aOutValue)) = get_double();
}

auto JSVariant::get(bool* aOutValue) const -> void
{
    (*(aOutValue)) = get_bool();
}

auto JSVariant::get(JSIID* aOutValue) const -> void
{
    (*(aOutValue)) = get_JSIID();
}

} // namespace jsipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |union JSIDVariant|
//
namespace mozilla {
namespace jsipc {
auto JSIDVariant::MaybeDestroy(Type aNewType) -> bool
{
    if ((mType) == (T__None)) {
        return true;
    }
    if ((mType) == (aNewType)) {
        return false;
    }
    switch (mType) {
    case TSymbolVariant:
        {
            (ptr_SymbolVariant())->~SymbolVariant__tdef();
            break;
        }
    case TnsString:
        {
            (ptr_nsString())->~nsString__tdef();
            break;
        }
    case Tint32_t:
        {
            (ptr_int32_t())->~int32_t__tdef();
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("not reached");
            break;
        }
    }
    return true;
}

MOZ_IMPLICIT JSIDVariant::JSIDVariant(const SymbolVariant& aOther)
{
    new (mozilla::KnownNotNull, ptr_SymbolVariant()) SymbolVariant(aOther);
    mType = TSymbolVariant;
}

MOZ_IMPLICIT JSIDVariant::JSIDVariant(SymbolVariant&& aOther)
{
    new (mozilla::KnownNotNull, ptr_SymbolVariant()) SymbolVariant(mozilla::Move(aOther));
    mType = TSymbolVariant;
}

MOZ_IMPLICIT JSIDVariant::JSIDVariant(const nsString& aOther)
{
    new (mozilla::KnownNotNull, ptr_nsString()) nsString(aOther);
    mType = TnsString;
}

MOZ_IMPLICIT JSIDVariant::JSIDVariant(nsString&& aOther)
{
    new (mozilla::KnownNotNull, ptr_nsString()) nsString(mozilla::Move(aOther));
    mType = TnsString;
}

MOZ_IMPLICIT JSIDVariant::JSIDVariant(const int32_t& aOther)
{
    new (mozilla::KnownNotNull, ptr_int32_t()) int32_t(aOther);
    mType = Tint32_t;
}

MOZ_IMPLICIT JSIDVariant::JSIDVariant(int32_t&& aOther)
{
    new (mozilla::KnownNotNull, ptr_int32_t()) int32_t(mozilla::Move(aOther));
    mType = Tint32_t;
}

MOZ_IMPLICIT JSIDVariant::JSIDVariant(const JSIDVariant& aOther)
{
    (aOther).AssertSanity();
    switch ((aOther).type()) {
    case TSymbolVariant:
        {
            new (mozilla::KnownNotNull, ptr_SymbolVariant()) SymbolVariant((aOther).get_SymbolVariant());
            break;
        }
    case TnsString:
        {
            new (mozilla::KnownNotNull, ptr_nsString()) nsString((aOther).get_nsString());
            break;
        }
    case Tint32_t:
        {
            new (mozilla::KnownNotNull, ptr_int32_t()) int32_t((aOther).get_int32_t());
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    mType = (aOther).type();
}

MOZ_IMPLICIT JSIDVariant::JSIDVariant(JSIDVariant&& aOther)
{
    (aOther).AssertSanity();
    Type t = (aOther).type();
    switch (t) {
    case TSymbolVariant:
        {
            new (mozilla::KnownNotNull, ptr_SymbolVariant()) SymbolVariant(mozilla::Move((aOther).get_SymbolVariant()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case TnsString:
        {
            new (mozilla::KnownNotNull, ptr_nsString()) nsString(mozilla::Move((aOther).get_nsString()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case Tint32_t:
        {
            new (mozilla::KnownNotNull, ptr_int32_t()) int32_t(mozilla::Move((aOther).get_int32_t()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    (aOther).mType = T__None;
    mType = t;
}

JSIDVariant::~JSIDVariant()
{
    static_cast<void>(MaybeDestroy(T__None));
}

auto JSIDVariant::operator=(const SymbolVariant& aRhs) -> JSIDVariant&
{
    if (MaybeDestroy(TSymbolVariant)) {
        new (mozilla::KnownNotNull, ptr_SymbolVariant()) SymbolVariant;
    }
    (*(ptr_SymbolVariant())) = aRhs;
    mType = TSymbolVariant;
    return (*(this));
}

auto JSIDVariant::operator=(SymbolVariant&& aRhs) -> JSIDVariant&
{
    if (MaybeDestroy(TSymbolVariant)) {
        new (mozilla::KnownNotNull, ptr_SymbolVariant()) SymbolVariant;
    }
    (*(ptr_SymbolVariant())) = mozilla::Move(aRhs);
    mType = TSymbolVariant;
    return (*(this));
}

auto JSIDVariant::operator=(const nsString& aRhs) -> JSIDVariant&
{
    if (MaybeDestroy(TnsString)) {
        new (mozilla::KnownNotNull, ptr_nsString()) nsString;
    }
    (*(ptr_nsString())) = aRhs;
    mType = TnsString;
    return (*(this));
}

auto JSIDVariant::operator=(nsString&& aRhs) -> JSIDVariant&
{
    if (MaybeDestroy(TnsString)) {
        new (mozilla::KnownNotNull, ptr_nsString()) nsString;
    }
    (*(ptr_nsString())) = mozilla::Move(aRhs);
    mType = TnsString;
    return (*(this));
}

auto JSIDVariant::operator=(const int32_t& aRhs) -> JSIDVariant&
{
    if (MaybeDestroy(Tint32_t)) {
        new (mozilla::KnownNotNull, ptr_int32_t()) int32_t;
    }
    (*(ptr_int32_t())) = aRhs;
    mType = Tint32_t;
    return (*(this));
}

auto JSIDVariant::operator=(int32_t&& aRhs) -> JSIDVariant&
{
    if (MaybeDestroy(Tint32_t)) {
        new (mozilla::KnownNotNull, ptr_int32_t()) int32_t;
    }
    (*(ptr_int32_t())) = mozilla::Move(aRhs);
    mType = Tint32_t;
    return (*(this));
}

auto JSIDVariant::operator=(const JSIDVariant& aRhs) -> JSIDVariant&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TSymbolVariant:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_SymbolVariant()) SymbolVariant;
            }
            (*(ptr_SymbolVariant())) = (aRhs).get_SymbolVariant();
            break;
        }
    case TnsString:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_nsString()) nsString;
            }
            (*(ptr_nsString())) = (aRhs).get_nsString();
            break;
        }
    case Tint32_t:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_int32_t()) int32_t;
            }
            (*(ptr_int32_t())) = (aRhs).get_int32_t();
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    mType = t;
    return (*(this));
}

auto JSIDVariant::operator=(JSIDVariant&& aRhs) -> JSIDVariant&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TSymbolVariant:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_SymbolVariant()) SymbolVariant;
            }
            (*(ptr_SymbolVariant())) = mozilla::Move((aRhs).get_SymbolVariant());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case TnsString:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_nsString()) nsString;
            }
            (*(ptr_nsString())) = mozilla::Move((aRhs).get_nsString());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case Tint32_t:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_int32_t()) int32_t;
            }
            (*(ptr_int32_t())) = mozilla::Move((aRhs).get_int32_t());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    (aRhs).mType = T__None;
    mType = t;
    return (*(this));
}

auto JSIDVariant::operator==(const SymbolVariant& aRhs) const -> bool
{
    return (get_SymbolVariant()) == (aRhs);
}

auto JSIDVariant::operator==(const nsString& aRhs) const -> bool
{
    return (get_nsString()) == (aRhs);
}

auto JSIDVariant::operator==(const int32_t& aRhs) const -> bool
{
    return (get_int32_t()) == (aRhs);
}

auto JSIDVariant::operator==(const JSIDVariant& aRhs) const -> bool
{
    if ((type()) != ((aRhs).type())) {
        return false;
    }

    switch (type()) {
    case TSymbolVariant:
        {
            return (get_SymbolVariant()) == ((aRhs).get_SymbolVariant());
        }
    case TnsString:
        {
            return (get_nsString()) == ((aRhs).get_nsString());
        }
    case Tint32_t:
        {
            return (get_int32_t()) == ((aRhs).get_int32_t());
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return false;
        }
    }
}

auto JSIDVariant::get(SymbolVariant* aOutValue) const -> void
{
    (*(aOutValue)) = get_SymbolVariant();
}

auto JSIDVariant::get(nsString* aOutValue) const -> void
{
    (*(aOutValue)) = get_nsString();
}

auto JSIDVariant::get(int32_t* aOutValue) const -> void
{
    (*(aOutValue)) = get_int32_t();
}

} // namespace jsipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct ReturnSuccess|
//
namespace mozilla {
namespace jsipc {
auto ReturnSuccess::operator==(const ReturnSuccess& _o) const -> bool
{
    return true;
}

auto ReturnSuccess::operator!=(const ReturnSuccess& _o) const -> bool
{
    return (!(operator==(_o)));
}

} // namespace jsipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct ReturnDeadCPOW|
//
namespace mozilla {
namespace jsipc {
auto ReturnDeadCPOW::operator==(const ReturnDeadCPOW& _o) const -> bool
{
    return true;
}

auto ReturnDeadCPOW::operator!=(const ReturnDeadCPOW& _o) const -> bool
{
    return (!(operator==(_o)));
}

} // namespace jsipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct ReturnException|
//
namespace mozilla {
namespace jsipc {
auto ReturnException::operator==(const ReturnException& _o) const -> bool
{
    if ((!((exn()) == ((_o).exn())))) {
        return false;
    }
    return true;
}

auto ReturnException::operator!=(const ReturnException& _o) const -> bool
{
    return (!(operator==(_o)));
}

} // namespace jsipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct ReturnObjectOpResult|
//
namespace mozilla {
namespace jsipc {
auto ReturnObjectOpResult::operator==(const ReturnObjectOpResult& _o) const -> bool
{
    if ((!((code()) == ((_o).code())))) {
        return false;
    }
    return true;
}

auto ReturnObjectOpResult::operator!=(const ReturnObjectOpResult& _o) const -> bool
{
    return (!(operator==(_o)));
}

} // namespace jsipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |union ReturnStatus|
//
namespace mozilla {
namespace jsipc {
auto ReturnStatus::MaybeDestroy(Type aNewType) -> bool
{
    if ((mType) == (T__None)) {
        return true;
    }
    if ((mType) == (aNewType)) {
        return false;
    }
    switch (mType) {
    case TReturnSuccess:
        {
            (ptr_ReturnSuccess())->~ReturnSuccess__tdef();
            break;
        }
    case TReturnDeadCPOW:
        {
            (ptr_ReturnDeadCPOW())->~ReturnDeadCPOW__tdef();
            break;
        }
    case TReturnException:
        {
            (ptr_ReturnException())->~ReturnException__tdef();
            break;
        }
    case TReturnObjectOpResult:
        {
            (ptr_ReturnObjectOpResult())->~ReturnObjectOpResult__tdef();
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("not reached");
            break;
        }
    }
    return true;
}

MOZ_IMPLICIT ReturnStatus::ReturnStatus(const ReturnSuccess& aOther)
{
    new (mozilla::KnownNotNull, ptr_ReturnSuccess()) ReturnSuccess(aOther);
    mType = TReturnSuccess;
}

MOZ_IMPLICIT ReturnStatus::ReturnStatus(ReturnSuccess&& aOther)
{
    new (mozilla::KnownNotNull, ptr_ReturnSuccess()) ReturnSuccess(mozilla::Move(aOther));
    mType = TReturnSuccess;
}

MOZ_IMPLICIT ReturnStatus::ReturnStatus(const ReturnDeadCPOW& aOther)
{
    new (mozilla::KnownNotNull, ptr_ReturnDeadCPOW()) ReturnDeadCPOW(aOther);
    mType = TReturnDeadCPOW;
}

MOZ_IMPLICIT ReturnStatus::ReturnStatus(ReturnDeadCPOW&& aOther)
{
    new (mozilla::KnownNotNull, ptr_ReturnDeadCPOW()) ReturnDeadCPOW(mozilla::Move(aOther));
    mType = TReturnDeadCPOW;
}

MOZ_IMPLICIT ReturnStatus::ReturnStatus(const ReturnException& aOther)
{
    new (mozilla::KnownNotNull, ptr_ReturnException()) ReturnException(aOther);
    mType = TReturnException;
}

MOZ_IMPLICIT ReturnStatus::ReturnStatus(ReturnException&& aOther)
{
    new (mozilla::KnownNotNull, ptr_ReturnException()) ReturnException(mozilla::Move(aOther));
    mType = TReturnException;
}

MOZ_IMPLICIT ReturnStatus::ReturnStatus(const ReturnObjectOpResult& aOther)
{
    new (mozilla::KnownNotNull, ptr_ReturnObjectOpResult()) ReturnObjectOpResult(aOther);
    mType = TReturnObjectOpResult;
}

MOZ_IMPLICIT ReturnStatus::ReturnStatus(ReturnObjectOpResult&& aOther)
{
    new (mozilla::KnownNotNull, ptr_ReturnObjectOpResult()) ReturnObjectOpResult(mozilla::Move(aOther));
    mType = TReturnObjectOpResult;
}

MOZ_IMPLICIT ReturnStatus::ReturnStatus(const ReturnStatus& aOther)
{
    (aOther).AssertSanity();
    switch ((aOther).type()) {
    case TReturnSuccess:
        {
            new (mozilla::KnownNotNull, ptr_ReturnSuccess()) ReturnSuccess((aOther).get_ReturnSuccess());
            break;
        }
    case TReturnDeadCPOW:
        {
            new (mozilla::KnownNotNull, ptr_ReturnDeadCPOW()) ReturnDeadCPOW((aOther).get_ReturnDeadCPOW());
            break;
        }
    case TReturnException:
        {
            new (mozilla::KnownNotNull, ptr_ReturnException()) ReturnException((aOther).get_ReturnException());
            break;
        }
    case TReturnObjectOpResult:
        {
            new (mozilla::KnownNotNull, ptr_ReturnObjectOpResult()) ReturnObjectOpResult((aOther).get_ReturnObjectOpResult());
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    mType = (aOther).type();
}

MOZ_IMPLICIT ReturnStatus::ReturnStatus(ReturnStatus&& aOther)
{
    (aOther).AssertSanity();
    Type t = (aOther).type();
    switch (t) {
    case TReturnSuccess:
        {
            new (mozilla::KnownNotNull, ptr_ReturnSuccess()) ReturnSuccess(mozilla::Move((aOther).get_ReturnSuccess()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case TReturnDeadCPOW:
        {
            new (mozilla::KnownNotNull, ptr_ReturnDeadCPOW()) ReturnDeadCPOW(mozilla::Move((aOther).get_ReturnDeadCPOW()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case TReturnException:
        {
            new (mozilla::KnownNotNull, ptr_ReturnException()) ReturnException(mozilla::Move((aOther).get_ReturnException()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case TReturnObjectOpResult:
        {
            new (mozilla::KnownNotNull, ptr_ReturnObjectOpResult()) ReturnObjectOpResult(mozilla::Move((aOther).get_ReturnObjectOpResult()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    (aOther).mType = T__None;
    mType = t;
}

ReturnStatus::~ReturnStatus()
{
    static_cast<void>(MaybeDestroy(T__None));
}

auto ReturnStatus::operator=(const ReturnSuccess& aRhs) -> ReturnStatus&
{
    if (MaybeDestroy(TReturnSuccess)) {
        new (mozilla::KnownNotNull, ptr_ReturnSuccess()) ReturnSuccess;
    }
    (*(ptr_ReturnSuccess())) = aRhs;
    mType = TReturnSuccess;
    return (*(this));
}

auto ReturnStatus::operator=(ReturnSuccess&& aRhs) -> ReturnStatus&
{
    if (MaybeDestroy(TReturnSuccess)) {
        new (mozilla::KnownNotNull, ptr_ReturnSuccess()) ReturnSuccess;
    }
    (*(ptr_ReturnSuccess())) = mozilla::Move(aRhs);
    mType = TReturnSuccess;
    return (*(this));
}

auto ReturnStatus::operator=(const ReturnDeadCPOW& aRhs) -> ReturnStatus&
{
    if (MaybeDestroy(TReturnDeadCPOW)) {
        new (mozilla::KnownNotNull, ptr_ReturnDeadCPOW()) ReturnDeadCPOW;
    }
    (*(ptr_ReturnDeadCPOW())) = aRhs;
    mType = TReturnDeadCPOW;
    return (*(this));
}

auto ReturnStatus::operator=(ReturnDeadCPOW&& aRhs) -> ReturnStatus&
{
    if (MaybeDestroy(TReturnDeadCPOW)) {
        new (mozilla::KnownNotNull, ptr_ReturnDeadCPOW()) ReturnDeadCPOW;
    }
    (*(ptr_ReturnDeadCPOW())) = mozilla::Move(aRhs);
    mType = TReturnDeadCPOW;
    return (*(this));
}

auto ReturnStatus::operator=(const ReturnException& aRhs) -> ReturnStatus&
{
    if (MaybeDestroy(TReturnException)) {
        new (mozilla::KnownNotNull, ptr_ReturnException()) ReturnException;
    }
    (*(ptr_ReturnException())) = aRhs;
    mType = TReturnException;
    return (*(this));
}

auto ReturnStatus::operator=(ReturnException&& aRhs) -> ReturnStatus&
{
    if (MaybeDestroy(TReturnException)) {
        new (mozilla::KnownNotNull, ptr_ReturnException()) ReturnException;
    }
    (*(ptr_ReturnException())) = mozilla::Move(aRhs);
    mType = TReturnException;
    return (*(this));
}

auto ReturnStatus::operator=(const ReturnObjectOpResult& aRhs) -> ReturnStatus&
{
    if (MaybeDestroy(TReturnObjectOpResult)) {
        new (mozilla::KnownNotNull, ptr_ReturnObjectOpResult()) ReturnObjectOpResult;
    }
    (*(ptr_ReturnObjectOpResult())) = aRhs;
    mType = TReturnObjectOpResult;
    return (*(this));
}

auto ReturnStatus::operator=(ReturnObjectOpResult&& aRhs) -> ReturnStatus&
{
    if (MaybeDestroy(TReturnObjectOpResult)) {
        new (mozilla::KnownNotNull, ptr_ReturnObjectOpResult()) ReturnObjectOpResult;
    }
    (*(ptr_ReturnObjectOpResult())) = mozilla::Move(aRhs);
    mType = TReturnObjectOpResult;
    return (*(this));
}

auto ReturnStatus::operator=(const ReturnStatus& aRhs) -> ReturnStatus&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TReturnSuccess:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_ReturnSuccess()) ReturnSuccess;
            }
            (*(ptr_ReturnSuccess())) = (aRhs).get_ReturnSuccess();
            break;
        }
    case TReturnDeadCPOW:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_ReturnDeadCPOW()) ReturnDeadCPOW;
            }
            (*(ptr_ReturnDeadCPOW())) = (aRhs).get_ReturnDeadCPOW();
            break;
        }
    case TReturnException:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_ReturnException()) ReturnException;
            }
            (*(ptr_ReturnException())) = (aRhs).get_ReturnException();
            break;
        }
    case TReturnObjectOpResult:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_ReturnObjectOpResult()) ReturnObjectOpResult;
            }
            (*(ptr_ReturnObjectOpResult())) = (aRhs).get_ReturnObjectOpResult();
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    mType = t;
    return (*(this));
}

auto ReturnStatus::operator=(ReturnStatus&& aRhs) -> ReturnStatus&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TReturnSuccess:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_ReturnSuccess()) ReturnSuccess;
            }
            (*(ptr_ReturnSuccess())) = mozilla::Move((aRhs).get_ReturnSuccess());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case TReturnDeadCPOW:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_ReturnDeadCPOW()) ReturnDeadCPOW;
            }
            (*(ptr_ReturnDeadCPOW())) = mozilla::Move((aRhs).get_ReturnDeadCPOW());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case TReturnException:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_ReturnException()) ReturnException;
            }
            (*(ptr_ReturnException())) = mozilla::Move((aRhs).get_ReturnException());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case TReturnObjectOpResult:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_ReturnObjectOpResult()) ReturnObjectOpResult;
            }
            (*(ptr_ReturnObjectOpResult())) = mozilla::Move((aRhs).get_ReturnObjectOpResult());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    (aRhs).mType = T__None;
    mType = t;
    return (*(this));
}

auto ReturnStatus::operator==(const ReturnSuccess& aRhs) const -> bool
{
    return (get_ReturnSuccess()) == (aRhs);
}

auto ReturnStatus::operator==(const ReturnDeadCPOW& aRhs) const -> bool
{
    return (get_ReturnDeadCPOW()) == (aRhs);
}

auto ReturnStatus::operator==(const ReturnException& aRhs) const -> bool
{
    return (get_ReturnException()) == (aRhs);
}

auto ReturnStatus::operator==(const ReturnObjectOpResult& aRhs) const -> bool
{
    return (get_ReturnObjectOpResult()) == (aRhs);
}

auto ReturnStatus::operator==(const ReturnStatus& aRhs) const -> bool
{
    if ((type()) != ((aRhs).type())) {
        return false;
    }

    switch (type()) {
    case TReturnSuccess:
        {
            return (get_ReturnSuccess()) == ((aRhs).get_ReturnSuccess());
        }
    case TReturnDeadCPOW:
        {
            return (get_ReturnDeadCPOW()) == ((aRhs).get_ReturnDeadCPOW());
        }
    case TReturnException:
        {
            return (get_ReturnException()) == ((aRhs).get_ReturnException());
        }
    case TReturnObjectOpResult:
        {
            return (get_ReturnObjectOpResult()) == ((aRhs).get_ReturnObjectOpResult());
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return false;
        }
    }
}

auto ReturnStatus::get(ReturnSuccess* aOutValue) const -> void
{
    (*(aOutValue)) = get_ReturnSuccess();
}

auto ReturnStatus::get(ReturnDeadCPOW* aOutValue) const -> void
{
    (*(aOutValue)) = get_ReturnDeadCPOW();
}

auto ReturnStatus::get(ReturnException* aOutValue) const -> void
{
    (*(aOutValue)) = get_ReturnException();
}

auto ReturnStatus::get(ReturnObjectOpResult* aOutValue) const -> void
{
    (*(aOutValue)) = get_ReturnObjectOpResult();
}

} // namespace jsipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |union JSParam|
//
namespace mozilla {
namespace jsipc {
auto JSParam::MaybeDestroy(Type aNewType) -> bool
{
    if ((mType) == (T__None)) {
        return true;
    }
    if ((mType) == (aNewType)) {
        return false;
    }
    switch (mType) {
    case Tvoid_t:
        {
            (ptr_void_t())->~void_t__tdef();
            break;
        }
    case TJSVariant:
        {
            (ptr_JSVariant())->~JSVariant__tdef();
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("not reached");
            break;
        }
    }
    return true;
}

MOZ_IMPLICIT JSParam::JSParam(const void_t& aOther)
{
    new (mozilla::KnownNotNull, ptr_void_t()) void_t(aOther);
    mType = Tvoid_t;
}

MOZ_IMPLICIT JSParam::JSParam(void_t&& aOther)
{
    new (mozilla::KnownNotNull, ptr_void_t()) void_t(mozilla::Move(aOther));
    mType = Tvoid_t;
}

MOZ_IMPLICIT JSParam::JSParam(const JSVariant& aOther)
{
    new (mozilla::KnownNotNull, ptr_JSVariant()) JSVariant(aOther);
    mType = TJSVariant;
}

MOZ_IMPLICIT JSParam::JSParam(JSVariant&& aOther)
{
    new (mozilla::KnownNotNull, ptr_JSVariant()) JSVariant(mozilla::Move(aOther));
    mType = TJSVariant;
}

MOZ_IMPLICIT JSParam::JSParam(const JSParam& aOther)
{
    (aOther).AssertSanity();
    switch ((aOther).type()) {
    case Tvoid_t:
        {
            new (mozilla::KnownNotNull, ptr_void_t()) void_t((aOther).get_void_t());
            break;
        }
    case TJSVariant:
        {
            new (mozilla::KnownNotNull, ptr_JSVariant()) JSVariant((aOther).get_JSVariant());
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    mType = (aOther).type();
}

MOZ_IMPLICIT JSParam::JSParam(JSParam&& aOther)
{
    (aOther).AssertSanity();
    Type t = (aOther).type();
    switch (t) {
    case Tvoid_t:
        {
            new (mozilla::KnownNotNull, ptr_void_t()) void_t(mozilla::Move((aOther).get_void_t()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case TJSVariant:
        {
            new (mozilla::KnownNotNull, ptr_JSVariant()) JSVariant(mozilla::Move((aOther).get_JSVariant()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    (aOther).mType = T__None;
    mType = t;
}

JSParam::~JSParam()
{
    static_cast<void>(MaybeDestroy(T__None));
}

auto JSParam::operator=(const void_t& aRhs) -> JSParam&
{
    if (MaybeDestroy(Tvoid_t)) {
        new (mozilla::KnownNotNull, ptr_void_t()) void_t;
    }
    (*(ptr_void_t())) = aRhs;
    mType = Tvoid_t;
    return (*(this));
}

auto JSParam::operator=(void_t&& aRhs) -> JSParam&
{
    if (MaybeDestroy(Tvoid_t)) {
        new (mozilla::KnownNotNull, ptr_void_t()) void_t;
    }
    (*(ptr_void_t())) = mozilla::Move(aRhs);
    mType = Tvoid_t;
    return (*(this));
}

auto JSParam::operator=(const JSVariant& aRhs) -> JSParam&
{
    if (MaybeDestroy(TJSVariant)) {
        new (mozilla::KnownNotNull, ptr_JSVariant()) JSVariant;
    }
    (*(ptr_JSVariant())) = aRhs;
    mType = TJSVariant;
    return (*(this));
}

auto JSParam::operator=(JSVariant&& aRhs) -> JSParam&
{
    if (MaybeDestroy(TJSVariant)) {
        new (mozilla::KnownNotNull, ptr_JSVariant()) JSVariant;
    }
    (*(ptr_JSVariant())) = mozilla::Move(aRhs);
    mType = TJSVariant;
    return (*(this));
}

auto JSParam::operator=(const JSParam& aRhs) -> JSParam&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case Tvoid_t:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_void_t()) void_t;
            }
            (*(ptr_void_t())) = (aRhs).get_void_t();
            break;
        }
    case TJSVariant:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_JSVariant()) JSVariant;
            }
            (*(ptr_JSVariant())) = (aRhs).get_JSVariant();
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    mType = t;
    return (*(this));
}

auto JSParam::operator=(JSParam&& aRhs) -> JSParam&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case Tvoid_t:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_void_t()) void_t;
            }
            (*(ptr_void_t())) = mozilla::Move((aRhs).get_void_t());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case TJSVariant:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_JSVariant()) JSVariant;
            }
            (*(ptr_JSVariant())) = mozilla::Move((aRhs).get_JSVariant());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    (aRhs).mType = T__None;
    mType = t;
    return (*(this));
}

auto JSParam::operator==(const void_t& aRhs) const -> bool
{
    return (get_void_t()) == (aRhs);
}

auto JSParam::operator==(const JSVariant& aRhs) const -> bool
{
    return (get_JSVariant()) == (aRhs);
}

auto JSParam::operator==(const JSParam& aRhs) const -> bool
{
    if ((type()) != ((aRhs).type())) {
        return false;
    }

    switch (type()) {
    case Tvoid_t:
        {
            return (get_void_t()) == ((aRhs).get_void_t());
        }
    case TJSVariant:
        {
            return (get_JSVariant()) == ((aRhs).get_JSVariant());
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return false;
        }
    }
}

auto JSParam::get(void_t* aOutValue) const -> void
{
    (*(aOutValue)) = get_void_t();
}

auto JSParam::get(JSVariant* aOutValue) const -> void
{
    (*(aOutValue)) = get_JSVariant();
}

} // namespace jsipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |union GetterSetter|
//
namespace mozilla {
namespace jsipc {
auto GetterSetter::MaybeDestroy(Type aNewType) -> bool
{
    if ((mType) == (T__None)) {
        return true;
    }
    if ((mType) == (aNewType)) {
        return false;
    }
    switch (mType) {
    case Tuint64_t:
        {
            (ptr_uint64_t())->~uint64_t__tdef();
            break;
        }
    case TObjectVariant:
        {
            (ptr_ObjectVariant())->~ObjectVariant__tdef();
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("not reached");
            break;
        }
    }
    return true;
}

MOZ_IMPLICIT GetterSetter::GetterSetter(const uint64_t& aOther)
{
    new (mozilla::KnownNotNull, ptr_uint64_t()) uint64_t(aOther);
    mType = Tuint64_t;
}

MOZ_IMPLICIT GetterSetter::GetterSetter(uint64_t&& aOther)
{
    new (mozilla::KnownNotNull, ptr_uint64_t()) uint64_t(mozilla::Move(aOther));
    mType = Tuint64_t;
}

MOZ_IMPLICIT GetterSetter::GetterSetter(const ObjectVariant& aOther)
{
    new (mozilla::KnownNotNull, ptr_ObjectVariant()) ObjectVariant(aOther);
    mType = TObjectVariant;
}

MOZ_IMPLICIT GetterSetter::GetterSetter(ObjectVariant&& aOther)
{
    new (mozilla::KnownNotNull, ptr_ObjectVariant()) ObjectVariant(mozilla::Move(aOther));
    mType = TObjectVariant;
}

MOZ_IMPLICIT GetterSetter::GetterSetter(const GetterSetter& aOther)
{
    (aOther).AssertSanity();
    switch ((aOther).type()) {
    case Tuint64_t:
        {
            new (mozilla::KnownNotNull, ptr_uint64_t()) uint64_t((aOther).get_uint64_t());
            break;
        }
    case TObjectVariant:
        {
            new (mozilla::KnownNotNull, ptr_ObjectVariant()) ObjectVariant((aOther).get_ObjectVariant());
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    mType = (aOther).type();
}

MOZ_IMPLICIT GetterSetter::GetterSetter(GetterSetter&& aOther)
{
    (aOther).AssertSanity();
    Type t = (aOther).type();
    switch (t) {
    case Tuint64_t:
        {
            new (mozilla::KnownNotNull, ptr_uint64_t()) uint64_t(mozilla::Move((aOther).get_uint64_t()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case TObjectVariant:
        {
            new (mozilla::KnownNotNull, ptr_ObjectVariant()) ObjectVariant(mozilla::Move((aOther).get_ObjectVariant()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    (aOther).mType = T__None;
    mType = t;
}

GetterSetter::~GetterSetter()
{
    static_cast<void>(MaybeDestroy(T__None));
}

auto GetterSetter::operator=(const uint64_t& aRhs) -> GetterSetter&
{
    if (MaybeDestroy(Tuint64_t)) {
        new (mozilla::KnownNotNull, ptr_uint64_t()) uint64_t;
    }
    (*(ptr_uint64_t())) = aRhs;
    mType = Tuint64_t;
    return (*(this));
}

auto GetterSetter::operator=(uint64_t&& aRhs) -> GetterSetter&
{
    if (MaybeDestroy(Tuint64_t)) {
        new (mozilla::KnownNotNull, ptr_uint64_t()) uint64_t;
    }
    (*(ptr_uint64_t())) = mozilla::Move(aRhs);
    mType = Tuint64_t;
    return (*(this));
}

auto GetterSetter::operator=(const ObjectVariant& aRhs) -> GetterSetter&
{
    if (MaybeDestroy(TObjectVariant)) {
        new (mozilla::KnownNotNull, ptr_ObjectVariant()) ObjectVariant;
    }
    (*(ptr_ObjectVariant())) = aRhs;
    mType = TObjectVariant;
    return (*(this));
}

auto GetterSetter::operator=(ObjectVariant&& aRhs) -> GetterSetter&
{
    if (MaybeDestroy(TObjectVariant)) {
        new (mozilla::KnownNotNull, ptr_ObjectVariant()) ObjectVariant;
    }
    (*(ptr_ObjectVariant())) = mozilla::Move(aRhs);
    mType = TObjectVariant;
    return (*(this));
}

auto GetterSetter::operator=(const GetterSetter& aRhs) -> GetterSetter&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case Tuint64_t:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_uint64_t()) uint64_t;
            }
            (*(ptr_uint64_t())) = (aRhs).get_uint64_t();
            break;
        }
    case TObjectVariant:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_ObjectVariant()) ObjectVariant;
            }
            (*(ptr_ObjectVariant())) = (aRhs).get_ObjectVariant();
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    mType = t;
    return (*(this));
}

auto GetterSetter::operator=(GetterSetter&& aRhs) -> GetterSetter&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case Tuint64_t:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_uint64_t()) uint64_t;
            }
            (*(ptr_uint64_t())) = mozilla::Move((aRhs).get_uint64_t());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case TObjectVariant:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_ObjectVariant()) ObjectVariant;
            }
            (*(ptr_ObjectVariant())) = mozilla::Move((aRhs).get_ObjectVariant());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    (aRhs).mType = T__None;
    mType = t;
    return (*(this));
}

auto GetterSetter::operator==(const uint64_t& aRhs) const -> bool
{
    return (get_uint64_t()) == (aRhs);
}

auto GetterSetter::operator==(const ObjectVariant& aRhs) const -> bool
{
    return (get_ObjectVariant()) == (aRhs);
}

auto GetterSetter::operator==(const GetterSetter& aRhs) const -> bool
{
    if ((type()) != ((aRhs).type())) {
        return false;
    }

    switch (type()) {
    case Tuint64_t:
        {
            return (get_uint64_t()) == ((aRhs).get_uint64_t());
        }
    case TObjectVariant:
        {
            return (get_ObjectVariant()) == ((aRhs).get_ObjectVariant());
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return false;
        }
    }
}

auto GetterSetter::get(uint64_t* aOutValue) const -> void
{
    (*(aOutValue)) = get_uint64_t();
}

auto GetterSetter::get(ObjectVariant* aOutValue) const -> void
{
    (*(aOutValue)) = get_ObjectVariant();
}

} // namespace jsipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct PPropertyDescriptor|
//
namespace mozilla {
namespace jsipc {
auto PPropertyDescriptor::operator==(const PPropertyDescriptor& _o) const -> bool
{
    if ((!((obj()) == ((_o).obj())))) {
        return false;
    }
    if ((!((attrs()) == ((_o).attrs())))) {
        return false;
    }
    if ((!((value()) == ((_o).value())))) {
        return false;
    }
    if ((!((getter()) == ((_o).getter())))) {
        return false;
    }
    if ((!((setter()) == ((_o).setter())))) {
        return false;
    }
    return true;
}

auto PPropertyDescriptor::operator!=(const PPropertyDescriptor& _o) const -> bool
{
    return (!(operator==(_o)));
}

} // namespace jsipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct CpowEntry|
//
namespace mozilla {
namespace jsipc {
auto CpowEntry::operator==(const CpowEntry& _o) const -> bool
{
    if ((!((name()) == ((_o).name())))) {
        return false;
    }
    if ((!((value()) == ((_o).value())))) {
        return false;
    }
    return true;
}

auto CpowEntry::operator!=(const CpowEntry& _o) const -> bool
{
    return (!(operator==(_o)));
}

} // namespace jsipc
} // namespace mozilla
